#! /usr/bin/python

from snack import *
from types import *

CS_TITLE=''

# Create a Listbox from a list
def LBXFromList(aList):
	l=Listbox(height=1,scroll=1,width=25)
	for sItem in aList:
		l.append(sItem,sItem)
	return l

def WidDict(wWidget, sType):
	dctSngWidget={}
	dctSngWidget['WIDGET']=wWidget
	dctSngWidget['TYPE']=sType
	return dctSngWidget

def CommentForm(screen, dctTemp):
	s=''
	for l in dctTemp['DLG_STRINGS']:
		s=s + l + ': ' + dctTemp['KEYS'][l]['COMMENT'] + '\n'
	rc=ButtonChoiceWindow( \
		screen, \
		CS_TITLE + dctTemp['TITLE'], \
		s, \
		width=70, \
		buttons = [ 'OK' ] \
	)
	return rc

class DictForm:
	def __init__(self, screen, dctTEMP):
		self.screen=screen
		self.dctWidgets={}
		self.dctCFG=dctTEMP
		self.dlgKEY=dctTEMP['KEYS']
		self.lstCFG=dctTEMP['DLG_STRINGS']
		self.title=dctTEMP['TITLE']
		self.sg=Grid(3, len(self.lstCFG)+2)
		self.bb=ButtonBar(self.screen, ['OK', 'CANCEL'])
		count=0
		for sTemp in self.lstCFG:
			sField=self.dlgKEY[sTemp]['VALUE']
			sType=type(sField)
			if sType==ListType:
				e=LBXFromList(sField)
				self.dctWidgets[sTemp]=WidDict(e, 'Listbox')
			elif sType==StringType:
				e=Entry(25)
				e.set(self.dlgKEY[sTemp]['VALUE'])
				self.dctWidgets[sTemp]=WidDict(e, 'Entry')
			self.sg.setField(Label(sTemp),0,count,padding=(0,0,1,0),anchorLeft=1)
			self.sg.setField(self.dctWidgets[sTemp]['WIDGET'],1,count,padding=(0,0,1,0),anchorLeft=1)
			self.sg.setField(Label(self.dlgKEY[sTemp]['HELP']),2,count,padding=(0,0,1,0),anchorLeft=1)
			count=count+1
		
		# create the Form
		self.frm=GridForm(self.screen, CS_TITLE + self.title, 1, 2)
		self.frm.add(self.sg,0,0)
		self.frm.add(self.bb,0,1)
		
	def run(self):
		rc=self.frm.runOnce()
		dctResults=self.dctCFG
		for sTemp in self.lstCFG:
			dct=self.dctWidgets[sTemp]
			sType=dct['TYPE']
			if sType=='Entry':
				dctResults['KEYS'][sTemp]['VALUE']=dct['WIDGET'].value()
			elif sType=='Listbox':
				dctResults['KEYS'][sTemp]['VALUE']=dct['WIDGET'].current()
		fOK=(self.bb.buttonPressed(rc)=='ok')
		return fOK, dctResults
